import { actionIsLoading } from '../../loading/action';

import {
  actionLogInSuccess,
  actionLogInReject,
  actionLogOutSuccess,
  actionLogOutReject,
} from '../action';

import { setToken, loginUser,updateCredentials,updateUserAvatar } from '../../../api-data';

const asyncCreateUser = (name:string, lastName: string,avatar:object) => async (dispatch:any) => {
  try {
    dispatch(actionIsLoading(true));
    await updateCredentials(name, lastName);
  } catch (e) {
    console.log(encodeURI)
  } finally {
    dispatch(actionIsLoading(false));
  }
};


const asyncLogin = (number:string, code: string,cb:() => void ) => async (dispatch:any) => {
  try {
    dispatch(actionIsLoading(true));
    const data = await loginUser<{token:string,registration: boolean}>(number, code);
    if (!data?.token) throw new Error('bad request')
    setToken.set(data.token)
    if (data?.registration) {
      cb()
    } else {
      dispatch(actionLogInSuccess(data.token))
    }
  } catch (e) {
    dispatch(actionLogInReject());
    cb()
  } finally {
    dispatch(actionIsLoading(false));
  }
};

const asyncLogout = () => async (dispatch:any) => {
  try {
    dispatch(actionIsLoading(true));
    dispatch(actionLogOutSuccess());
    localStorage.removeItem('isChecked')
    setToken.unset()
  } catch (e) {
    dispatch(actionLogOutReject());
  } finally {
    dispatch(actionIsLoading(false));
  }
};



export { asyncCreateUser, asyncLogin, asyncLogout };
